.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

AbsJJ MACRO arg
  mov eax, arg
  test eax, eax
  .if Sign?
	neg eax
  .endif
  EXITM <eax>
ENDM

SetAbsJJ MACRO arg
  ifdifi <eax>, <arg>
	mov eax, arg
  endif
  test eax, eax
  .if Sign?
	neg arg
  .endif
ENDM

ChkCorrect MACRO arg
if ChkC
  .if eax!=12345678
	INT 3
	mov &arg, &arg
  .endif
endif
ENDM

a16 MACRO
	align 16
	REPEAT 16
		retn 0		; tell the CPU there is nothing interesting before the proc
	ENDM
ENDM

.data
MyDwP	dd 12345678
MyDwN	dd -12345678

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	invoke GetCurrentProcess
	invoke SetProcessAffinityMask, eax, 1
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	ChkC =	0	; check for correct results - disable for timings
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push MyDwP
				call AbsLingo
				ChkCorrect eax
				mov MyDwP, eax
		counter_end
		print str$(eax), 9, "cycles for AbsLingo, pos", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push MyDwP
				call AbsJJp
				ChkCorrect ebx
				mov MyDwP, eax
		counter_end
		print str$(eax), 9, "cycles for AbsJJp proc, pos", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov MyDwP, AbsJJ(MyDwP)
				ChkCorrect ecx
		counter_end
		print str$(eax), 9, "cycles for mov arg, AbsJJ(arg), pos", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				SetAbsJJ MyDwP
				ChkCorrect edx
		counter_end
		print str$(eax), 9, "cycles for SetAbsJJ arg, pos", 13, 10
		print chr$(13, 10)

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push MyDwN
				call AbsLingo
				ChkCorrect esi
				mov MyDwN, eax
		counter_end
		print str$(eax), 9, "cycles for AbsLingo, neg", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push MyDwN
				call AbsJJp
				ChkCorrect edi
				mov MyDwN, eax
		counter_end
		print str$(eax), 9, "cycles for AbsJJp proc, neg", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov MyDwN, AbsJJ(MyDwN)
				ChkCorrect ebp
		counter_end
		print str$(eax), 9, "cycles for mov arg, AbsJJ(arg), neg", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				SetAbsJJ MyDwN
				ChkCorrect esp
		counter_end
		print str$(eax), 9, "cycles for SetAbsJJ arg, neg", 13, 10
		print chr$(13, 10)
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
a16
AbsJJp proc arg:DWORD
	mov eax, [esp+4]
	test eax, eax
	.if Sign?
		neg eax
	.endif
	ret 4
AbsJJp endp

a16
AbsLingo proc arg:DWORD
	if 0	; put 0 to see Lingo's algo, 1 to see JJ's algo in action
	mov eax, [esp+4]
	test eax, eax
	.if Sign?
		neg eax
	.endif
	ret 4
	else
	pop ecx
	pop eax
	cdq
	xor eax, edx
	sub eax, edx
	jmp ecx
	endif
AbsLingo endp

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]